package jogo;

import java.awt.Graphics;
import java.awt.Rectangle;
import javax.swing.JOptionPane;

public class Aviao extends Personagem {

    protected int cima; // código da tecla para mover para cima
    protected int baixo;// código da tecla para mover para baixo
    protected int direita;// código da tecla para mover para direita
    protected int esquerda;// código da tecla para mover para esquerda
    protected int atirar;
    private int pontuacao;
    private int quantidadeVida;
    private int combustivel;
    private int contadorPiscadas;
    private int relogioPiscada;
    private boolean fimDeJogo;

    public Aviao(int x, int y, Tela tela, int c, int b, int d, int e, int a, Cenario cen) {
        super(x, y, tela, "amiga", cen);
        this.cima = c;
        this.baixo = b;
        this.direita = d;
        this.esquerda = e;
        this.atirar = a;
        pontuacao = 0;
        this.quantidadeVida = 3;
        this.combustivel = 100;
        this.contadorPiscadas = 0;
        this.relogioPiscada = 0;
        this.fimDeJogo = false;
    }

    @Override
    public void atualizar() {
        this.processarTeclado();
    }

    @Override
    public void desenhar(Graphics g) {
        if (contadorPiscadas == 10) {
            this.vida = true;
            this.contadorPiscadas = 0;
        }
        if (this.combustivel < 0) {
            this.quantidadeVida = 0;
            this.morreu();
        } else {
            if (this.vida == false) {
                if (relogioPiscada % 2 == 0) {
                    g.drawImage(this.icone, this.tamanho * this.posX, this.tamanho * this.posY, tamanho, tamanho, this.principal);
                    relogioPiscada = 0;
                    System.out.println("PISCOU");
                }
                relogioPiscada++;
                contadorPiscadas++;
            } else {
                g.drawImage(this.icone, this.tamanho * this.posX, this.tamanho * this.posY, tamanho, tamanho, this.principal);
            }
        }
    }

    private void processarTeclado() {
        int destinoX = this.posX;
        int destinoY = this.posY;

        if (this.principal.pai.teclado.teclaApertada(this.cima)) {
            destinoY = destinoY - 1;
            this.combustivel = combustivel - 3;
        }
        if (this.principal.pai.teclado.teclaApertada(this.baixo)) {
            destinoY = destinoY + 1;
        }
        if (this.principal.pai.teclado.teclaApertada(this.esquerda)) {
            destinoX = destinoX - 1;
        }
        if (this.principal.pai.teclado.teclaApertada(this.direita)) {
            destinoX = destinoX + 1;
        }
        if (this.principal.pai.teclado.teclaApertada(this.atirar)) {
            Tiro t = new Tiro(this.posX * tamanho, this.posY * tamanho, this.principal, this.cen);
            this.principal.tiros.add(t);
        }
        if (destinoY > 19) {
            destinoY = 19;
        } else if (destinoY < 0) {
            destinoY = 0;
        }

        if (this.cen.getCenario()[destinoY][destinoX] == 0) {
            if (destinoX * this.tamanho < principal.getWidth()) {
                if (destinoX < 0) {
                    destinoX = 0;
                }
                this.posX = destinoX;
            }
            if (destinoY * this.tamanho < principal.getHeight()) {
                if (destinoY < 0) {
                    destinoY = 0;
                }
                this.posY = destinoY;
            }
        } else {
            this.posX = 9;
            this.posY = 18;
            this.morreu();
        }
    }

    public int obterPontuacao() {
        return this.pontuacao;
    }

    public void aumentarPontuacao() {
        this.pontuacao = pontuacao + 10;
    }

    public void diminuirPontuacao() {
        this.pontuacao = pontuacao - 10;
    }

    @Override
    public Rectangle obterRectangle() {
        return new Rectangle(posX * tamanho, posY * tamanho, tamanho, tamanho);
    }

    //verifica a morte
    public void morreu() {
        if (quantidadeVida == 0) {
            this.principal.pai.gerea.pausarJogo();
            JOptionPane.showMessageDialog(null, "FIM DE JOGO");
        } else {
            this.quantidadeVida--;
            this.vida = false;
        }
    }

    public void setarCombustivel(int c) {
        this.combustivel = c;
    }

    public int obterCombustível() {
        return this.combustivel;
    }

    public int vida() {
        return this.quantidadeVida;
    }
}
