package jogo;

import java.awt.Graphics;
import java.awt.Image;
import javax.swing.ImageIcon;

public class Cenario {
    
    private int[][] cenario = new int[20][20];
    //contador de linhas para fazer a copia
    private int contadorLinha;

    public Cenario(int[][] cen) {
        this.cenario = cen;
        this.contadorLinha = 19;
    }

    public int[][] getCenario() {
        return cenario;
    }

    //desce 1 linha na matriz e adiciona 0 na primeira linha
    public void descer1Linha() {
        int[][] copia = new int[20][20];
        for (int i = 0; i < 20; i++) { // linhas
            for (int u = 0; u < 20; u++) { //colunas
                copia[i][u] = cenario[i][u];
            }
        }
        for (int i = 0; i < 20; i++) { // linhas
            for (int u = 0; u < 20; u++) { //colunas
                if (i == 0) {
                    cenario[i][u] = 0;
                } else if (i > 0) {
                    cenario[i][u] = copia[i - 1][u];
                }
            }
        }
    }

    //copia a linha, indicada pelo contador, da matriz sequencia
    public int copiarLinha(int[][] cen) {
        if (contadorLinha == 0) {
            contadorLinha = 19;
        }
        for (int u = 0; u < 20; u++) { //colunas
            this.cenario[0][u] = cen[contadorLinha][u];
        }
        contadorLinha--;
        return contadorLinha;
    }

    //desenha a tabela na tela
    public void desenhar(Graphics g, Tela tela) {
        int altura = 34;
        int largura = 34;
        for (int i = 0; i < 20; i++) { // linhas
            for (int u = 0; u < 20; u++) { //colunas
                int vez = cenario[i][u];
                if (vez == 0) {
                    g.drawImage(carregarImagem("agua"), u * largura, i * altura, tela);
                } else if (vez == 1) {
                    g.drawImage(carregarImagem("terra"), u * largura, i * altura, tela);
                }else if(vez == 3){
                    g.drawImage(carregarImagem("navio"), u * largura, i * altura, tela);
                }
            }
        }
    }

    //carrega as imagens
    private Image carregarImagem(String imagem) {
        ImageIcon iicon = new ImageIcon(this.getClass().getResource("../imagens/" + imagem + ".png"));
        return iicon.getImage();
    }

    public boolean testarLocal(int local, int t){
        if(cenario[t][local] == 0){
            return true;
        }
        return false;
    }

    
}
