package jogo;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.Rectangle;
import javax.swing.ImageIcon;

public abstract class Personagem {

    protected int posX; // ponto X da bola
    protected int posY; // ponto Y da bola
    protected int tamanho; // constante 
    protected Tela principal;
    protected int velocidade;
    protected Image icone; // imagem do Aldeao
    protected String imagemNome; // nome da imagem do Aldeao
    protected Cenario cen;
    protected boolean vida;

    public Personagem(int x, int y, Tela tela, String PER, Cenario cen) {
        this.posX = x;
        this.posY = y;
        this.tamanho = 35;
        this.principal = tela;
        this.velocidade = 1;
        this.imagemNome = PER;
        this.icone = this.carregarImagem(this.imagemNome);
        this.cen = cen;
        this.vida = true;
    }

    public void desenhar(Graphics g) {
            g.drawImage(this.icone, this.posX, this.posY, tamanho, tamanho, this.principal);
    }

    public abstract void atualizar();

    public Rectangle obterRectangle() {
        return new Rectangle(posX, posY, tamanho, tamanho);
    }

    protected Image carregarImagem(String imagem) {
        ImageIcon iicon = new ImageIcon(this.getClass().getResource("../imagens/" + imagem + ".png"));
        return iicon.getImage();
    }

    public void alterarImagem() {
        this.imagemNome = "bomba";
        this.icone = this.carregarImagem(imagemNome);
    }

    public void alterarVida() {
        this.vida = false;
    }

    public boolean obterVida() {
        return this.vida;
    }
}